﻿Public Class Form1

    Dim summaryAppearance As Infragistics.Win.Appearance

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        
        Dim ds As New DataSet()
        Dim t1 As DataTable = ds.Tables.Add("table1")
        t1.Columns.Add("id", GetType(Integer)).AutoIncrement = True
        t1.Columns.Add("Name", GetType(String))
        t1.Columns.Add("Quantity", GetType(Integer))
        t1.Columns.Add("Total Quantity", GetType(Integer))
        t1.Columns.Add("Date", GetType(DateTime))
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Beverage", 50, 60, New DateTime(2008, 4, 22)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Beverage", 5, 20, New DateTime(2012, 5, 10)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Beverage", 20, 32, New DateTime(2005, 10, 5)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Beverage", 12, 79, New DateTime(2009, 2, 28)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Beverage", 40, 52, New DateTime(2008, 4, 22)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Books", 25, 28, New DateTime(2012, 5, 10)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Books", 30, 44, New DateTime(2005, 10, 5)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Books", 13, 200, New DateTime(2009, 2, 28)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Beverage", 60, 75, New DateTime(2008, 4, 22)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Beverage", 5, 30, New DateTime(2012, 5, 10)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Beverage", 10, 32, New DateTime(2005, 10, 5)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Beverage", 40, 69, New DateTime(2009, 2, 28)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Beverage", 24, 40, New DateTime(2008, 4, 22)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Books", 53, 55, New DateTime(2012, 5, 10)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Books", 42, 42, New DateTime(2005, 10, 5)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Books", 38, 44, New DateTime(2009, 2, 28)})
        UltraGrid1.DataSource = ds

    End Sub

    Private Sub UltraGrid1_InitializeLayout(sender As Object, e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs) Handles UltraGrid1.InitializeLayout
        'Add the GroupByRow
        e.Layout.Bands(0).SortedColumns.Add(e.Layout.Bands(0).Columns("Date"), False, True)
        e.Layout.Bands(0).SortedColumns.Add(e.Layout.Bands(0).Columns("Name"), False, True)
        'Enlarges the Column so the whole summary fits
        e.Layout.Bands(0).Columns("Total Quantity").Width = 200
        '
        e.Layout.Bands(0).SummaryFooterCaption = "Totals for Name [GROUPBYROWVALUE]"
        e.Layout.Override.SummaryDisplayArea = Infragistics.Win.UltraWinGrid.SummaryDisplayAreas.Default

        'Set the summary appearance
        summaryAppearance = New Infragistics.Win.Appearance()
        summaryAppearance.BackColor = Color.Salmon

        e.Layout.Override.SummaryFooterAppearance = summaryAppearance
        e.Layout.Override.SummaryFooterCaptionAppearance = summaryAppearance
        e.Layout.Override.SummaryValueAppearance = summaryAppearance

        ' e.Layout.Override.SummaryDisplayArea = Infragistics.Win.UltraWinGrid.SummaryDisplayAreas.Bottom
        'If you want the calculations to happen immediately instead once the GroupByRow has been expanded
        'Using this setting will make the grid perform slower when using large amounts of data
        UltraCalcManager1.DeferredCalculationsEnabled = False

        e.Layout.Bands(0).Summaries.Add(Infragistics.Win.UltraWinGrid.SummaryType.Sum,
                                                e.Layout.Bands(0).Columns("Quantity"))

        Dim formula As String = "sum([Quantity])/sum([Total Quantity])"



        e.Layout.Bands(0).Summaries.Add(formula, Infragistics.Win.UltraWinGrid.SummaryPosition.UseSummaryPositionColumn,
                                        e.Layout.Bands(0).Columns("Total Quantity"))


        'Formats the Summary to look as percentage
        e.Layout.Bands(0).Summaries(1).DisplayFormat = "Percentage = {0:P}"
    End Sub

End Class
